package test.microstream.integrations.spring.boot;

/*-
 * #%L
 * microstream-spring
 * %%
 * Copyright (C) 2019 - 2021 MicroStream Software
 * %%
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 * 
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the Eclipse
 * Public License, v. 2.0 are satisfied: GNU General Public License, version 2
 * with the GNU Classpath Exception which is
 * available at https://www.gnu.org/software/classpath/license.html.
 * 
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 * #L%
 */

import one.microstream.storage.embedded.types.EmbeddedStorageFoundation;
import one.microstream.storage.embedded.types.EmbeddedStorageManager;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

@SpringBootTest
public class ApplicationTest
{

    @Autowired
    private EmbeddedStorageFoundation<?> foundation;

    EmbeddedStorageManager storage = null;

    @AfterEach
    public void closeStorageAfterTest()
    {
        if (storage != null && storage.isRunning())
        {
            storage.shutdown();
        }

    }

    @Test
    public void storageBeanPresentTest()
    {
        Assertions.assertNotNull(foundation);

        storage = foundation.createEmbeddedStorageManager();
        storage.start();
        storage.setRoot("ahoj");
        storage.storeRoot();

    }

}
